﻿using Infragistics.Persistence;
using System;
using System.Collections.Generic;
using System.IO;
using System.IO.IsolatedStorage;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TileManagerStatePersist
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<Data> d = new List<Data>();
            for (int i = 0; i < 19; i++)
            {
                d.Add(new Data
                {
                    Content = "content for " + i,
                    Header = "Title " + i,
                });
            }
            DataContext = d;
        }
        private const string fileName = "tempFile";

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            // create the Persistence Settings object
            PersistenceSettings settings = new PersistenceSettings();
            // save all properties except those ignored
            settings.SavePersistenceOptions = Infragistics.Persistence.Primitives.PersistenceOption.AllButIgnored;
            // add the "Left" property as ignored
            PropertyNamePersistenceInfo prop1 = new PropertyNamePersistenceInfo
            {
                PropertyName = "Left"
            };
            settings.IgnorePropertySettings.Add(prop1);
            // add the "Top" property as ignored
            PropertyNamePersistenceInfo prop2 = new PropertyNamePersistenceInfo
            {
                PropertyName = "Top"
            };
            settings.IgnorePropertySettings.Add(prop2);
            // save the control's properties in a memory stream
            MemoryStream memoryStream =
                PersistenceManager.Save(tileManager, settings);

            using (FileStream stream = new FileStream(fileName, FileMode.Create, FileAccess.Write))
            {
                byte[] bytes = memoryStream.ToArray();

                stream.Write(bytes, 0, bytes.Length);
            } 
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            using (FileStream stream = new FileStream(fileName, FileMode.Open, FileAccess.Read))
            {
                PersistenceManager.Load(tileManager, stream);
            }
             

        }
    }

    public class Data
    {
        public string Header { get; set; }
        public string Content { get; set; }
    }
}
